static int latchPin = 2;
static int clockPin = 3;
static int dataPin = 4;
static int bits[] ={B10000000,B01000000,B00100000,B00010000,B00001000,B00000100,B00000010,B00000001};
static int anode = 10;
static byte numbers[]={0x03, 0x9f, 0x25, 0x0d, 0x99, 0x49, 0x41, 0x1f, 0x01, 0x09, 0x11, 0xc1, 0x63, 0x85, 0x61, 0x71, 0xfd, 0xef};
int bright=255;
int out=0;

byte outbytes[]={0x03, 0x03, 0x03, 0x03};

void setup() {
  //set up pins
  pinMode(anode,OUTPUT);
  pinMode(latchPin, OUTPUT);
  pinMode(clockPin, OUTPUT);
  pinMode(dataPin, OUTPUT);
  //zero the display
  writeout(0); 
  Serial.begin(9600); 
  Serial.println("init...OK"); 
}


void loop(){
    analogWrite(anode, bright);
    for (int i = 0; i < 9999; i++) {
      // count to 9999 - i'm sur eyou can think of better things to do
      delay(1500);
      writeout(i);
    }
      // a character has been written, delay for a bit
    
    // toggle the state of the pwm to control display
    bright = bright - 64;
    if (bright <1) 
        bright=255;
 }
    
void writeout(int value){

     
     //split value into base 10 digits
     int digit[] { value/1000, value%1000 /100,value%100/10,value%10};
     // turn off display
     analogWrite(anode,0);
     //disable the latch
     digitalWrite(latchPin,LOW);
     // if you have difficulties clocking in the right values, it is sometimes due to noise
     // a capacitor between  ground and the latch pin can help, as can a short delay
     // delay(5);

     //cycle through the digits     
     for (int p = 0; p < 4; p++) { 
        //get the byte value for the digit and send it out 
        shiftOut(dataPin, clockPin, LSBFIRST, numbers[digit[p]]);
     }
     digitalWrite(latchPin,HIGH);
     //turn display back on
     analogWrite(anode, bright);
}
    
