package com.example.maze;

import android.app.Activity;
import android.hardware.Sensor;
import android.hardware.SensorEvent;
import android.hardware.SensorEventListener;
import android.hardware.SensorManager;
import android.os.Bundle;
import android.util.Log;

// NB have to implement SensorEventListener
public class MazeActivity extends Activity implements SensorEventListener
{
  protected static MazeView maze;
  private SensorManager manager;
  private Sensor accel;
  private MazeBall ball;
  private static String TAG = "MazeActivity";

  /** Called when the activity is first created. */
  @Override
  public void onCreate(Bundle savedInstanceState) {
    super.onCreate(savedInstanceState);
    setContentView(R.layout.main);

    ball = (MazeBall)findViewById(R.id.mazeball);
    maze = (MazeView)findViewById(R.id.maze);
    manager = (SensorManager)getSystemService(SENSOR_SERVICE);
    accel = manager.getDefaultSensor(Sensor.TYPE_ACCELEROMETER);
  }

  protected void onResume() {
    super.onResume();
    manager.registerListener(this, accel, 
        SensorManager.SENSOR_DELAY_GAME);
  }

  protected void onPause() {
    super.onPause();
    manager.unregisterListener(this);
  }

  public void onAccuracyChanged(Sensor sensor, int accuracy) {
    ball.invalidate();
  }

  public void onSensorChanged(SensorEvent event) {
    ball.moveBall(event.values[0], event.values[1]);
    ball.invalidate();
  }
}
